#include "FakeD3DDevice.h"

struct ThiefVertex {
	float x,y,z,w;
	DWORD diffuse;
	DWORD spec;
	float u1, v1;
	float u2, v2;
};

FakeD3DDevice::FakeD3DDevice(IDirect3DDevice3* real) {
	Refs=1;
	Real=real;
}
IDirect3DDevice3* FakeD3DDevice::QueryReal() { return Real; }
/*** IUnknown methods ***/
HRESULT _stdcall FakeD3DDevice::QueryInterface(REFIID, LPVOID *) { UNUSEDFUNCTION; }
ULONG _stdcall FakeD3DDevice::AddRef() { return ++Refs; }
ULONG _stdcall FakeD3DDevice::Release() { COMMONRELEASE; }
/*** IDirect3DDevice3 methods ***/
HRESULT _stdcall FakeD3DDevice::GetCaps(LPD3DDEVICEDESC a,LPD3DDEVICEDESC b) {
//	return Real->GetCaps(a,b);
	CHECKFUNC(Real->GetCaps(a,b));
}
HRESULT _stdcall FakeD3DDevice::GetStats(LPD3DSTATS) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::AddViewport(LPDIRECT3DVIEWPORT3 a) {
	//return Real->AddViewport(a);
	CHECKFUNC(Real->AddViewport(a));
}
HRESULT _stdcall FakeD3DDevice::DeleteViewport(LPDIRECT3DVIEWPORT3) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::NextViewport(LPDIRECT3DVIEWPORT3,LPDIRECT3DVIEWPORT3*,DWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::EnumTextureFormats(LPD3DENUMPIXELFORMATSCALLBACK a,LPVOID b) {
	//return Real->EnumTextureFormats(a,b);
	CHECKFUNC(Real->EnumTextureFormats(a,b));
}
HRESULT _stdcall FakeD3DDevice::BeginScene() {
	//return Real->BeginScene();
	CHECKFUNC(Real->BeginScene());
}
HRESULT _stdcall FakeD3DDevice::EndScene() {
	//return Real->EndScene();
	CHECKFUNC(Real->EndScene());
}
HRESULT _stdcall FakeD3DDevice::GetDirect3D(LPDIRECT3D3*) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::SetCurrentViewport(LPDIRECT3DVIEWPORT3 a) {
	//return Real->SetCurrentViewport(a);
	CHECKFUNC(Real->SetCurrentViewport(a));
}
HRESULT _stdcall FakeD3DDevice::GetCurrentViewport(LPDIRECT3DVIEWPORT3 *) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::SetRenderTarget(LPDIRECTDRAWSURFACE4,DWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::GetRenderTarget(LPDIRECTDRAWSURFACE4 *) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::Begin(D3DPRIMITIVETYPE,DWORD,DWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::BeginIndexed(D3DPRIMITIVETYPE,DWORD,LPVOID,DWORD,DWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::Vertex(LPVOID) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::Index(WORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::End(DWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::GetRenderState(D3DRENDERSTATETYPE,LPDWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::SetRenderState(D3DRENDERSTATETYPE a,DWORD b) {
	//return Real->SetRenderState(a,b);
	CHECKFUNC(Real->SetRenderState(a,b));
}
HRESULT _stdcall FakeD3DDevice::GetLightState(D3DLIGHTSTATETYPE,LPDWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::SetLightState(D3DLIGHTSTATETYPE,DWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::SetTransform(D3DTRANSFORMSTATETYPE,LPD3DMATRIX) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::GetTransform(D3DTRANSFORMSTATETYPE,LPD3DMATRIX) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::MultiplyTransform(D3DTRANSFORMSTATETYPE,LPD3DMATRIX) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::DrawPrimitive(D3DPRIMITIVETYPE a,DWORD fvf,LPVOID ptr,DWORD count,DWORD e) {
	DWORD stride;
	if(fvf==0x1c4) stride=32;
	else stride=40;
	for(DWORD i=0;i<count;i++) {
		ThiefVertex* tv=(ThiefVertex*)((DWORD)ptr+i*stride);
		if(tv->z>1) tv->z=1.0f;
	}
	//return Real->DrawPrimitive(a,fvf,ptr,count,e);
	CHECKFUNC(Real->DrawPrimitive(a,fvf,ptr,count,e));
}
HRESULT _stdcall FakeD3DDevice::DrawIndexedPrimitive(D3DPRIMITIVETYPE a,DWORD b,LPVOID c,DWORD d,LPWORD e,DWORD f,DWORD g) {
	//return Real->DrawIndexedPrimitive(a,b,c,d,e,f,g);
	CHECKFUNC(Real->DrawIndexedPrimitive(a,b,c,d,e,f,g));
}
HRESULT _stdcall FakeD3DDevice::SetClipStatus(LPD3DCLIPSTATUS) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::GetClipStatus(LPD3DCLIPSTATUS) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::DrawPrimitiveStrided(D3DPRIMITIVETYPE,DWORD,LPD3DDRAWPRIMITIVESTRIDEDDATA,DWORD,DWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::DrawIndexedPrimitiveStrided(D3DPRIMITIVETYPE,DWORD,LPD3DDRAWPRIMITIVESTRIDEDDATA,DWORD,LPWORD,DWORD,DWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::DrawPrimitiveVB(D3DPRIMITIVETYPE,LPDIRECT3DVERTEXBUFFER,DWORD,DWORD,DWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::DrawIndexedPrimitiveVB(D3DPRIMITIVETYPE,LPDIRECT3DVERTEXBUFFER,LPWORD,DWORD,DWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::ComputeSphereVisibility(LPD3DVECTOR,LPD3DVALUE,DWORD,DWORD,LPDWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::GetTexture(DWORD,LPDIRECT3DTEXTURE2 *) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::SetTexture(DWORD a,LPDIRECT3DTEXTURE2 b) {
	//return Real->SetTexture(a,b);
	CHECKFUNC(Real->SetTexture(a,b));
}
HRESULT _stdcall FakeD3DDevice::GetTextureStageState(DWORD,D3DTEXTURESTAGESTATETYPE,LPDWORD) { UNUSEDFUNCTION; }
HRESULT _stdcall FakeD3DDevice::SetTextureStageState(DWORD a,D3DTEXTURESTAGESTATETYPE b,DWORD c) {
	//return Real->SetTextureStageState(a,b,c);
	CHECKFUNC(Real->SetTextureStageState(a,b,c));
}
HRESULT _stdcall FakeD3DDevice::ValidateDevice(LPDWORD a) {
	return Real->ValidateDevice(a);
}