
#include "main.h"

#include <shlobj.h>

#include "SafeWrite.h"
#include "FakeDirectDraw.h"
#include "BitmapSaver.h"

DWORD gWidth;
DWORD gHeight;
DWORD UseCompatibleZBuffer;
DWORD UseSysMemOverlay;
DWORD TextOverlayColourKey;

static FakeDirectDraw* SavedDirectDraw;

#ifdef CHECKEDBUILD
static HANDLE LogFile;
#endif

/*bool _stdcall SetWindowPosHook(HWND, HWND, int, int, int, int, int) { return true; }
bool _stdcall SetWindowLongHook(HWND, int, int) { return true; }
bool _stdcall ShowWindowHook(HWND, int) { return true; }*/

bool _stdcall DllMain(HANDLE hDllHandle, DWORD dwReason, LPVOID  lpreserved) {
	if(dwReason==DLL_PROCESS_ATTACH) {

		//Remove check for dodgy drivers
		//SafeWrite16(0x005BAA39, 0x9090);
		//SafeWrite16(0x005BAA3E, 0x9090);

		//SafeWrite32(0x00600304, (DWORD)SetWindowPosHook);
		//SafeWrite32(0x0060025C, (DWORD)SetWindowLongHook);
		//SafeWrite32(0x0060028C, (DWORD)ShowWindowHook);

		gWidth=GetPrivateProfileInt("Main", "gWidth", 800, ".\\ddfix.ini");
		gHeight=GetPrivateProfileInt("Main", "gHeight", 600, ".\\ddfix.ini");
		UseCompatibleZBuffer=GetPrivateProfileInt("Main", "UseCompatibleZBuffer", 0, ".\\ddfix.ini");
		UseSysMemOverlay=GetPrivateProfileInt("Main", "UseSysMemOverlay", 0, ".\\ddfix.ini");
		TextOverlayColourKey=GetPrivateProfileInt("Main", "OverlayColourKey", 0, ".\\ddfix.ini");
		if(gWidth==640&&gHeight==480) ExitProcess(1);

		/*AA=(BYTE)GetPrivateProfileInt("Main", "AA", 0, inipath);
		aniso=GetPrivateProfileInt("Main", "AnisotropicFiltering", 0, inipath)!=0;*/

		DWORD fix1=0, fix2=0;

		if(GetPrivateProfileInt("Main", "MultiCoreFix", 1, ".\\ddfix.ini")) {
			fix1=1;
			HANDLE process=GetCurrentProcess();
			SetProcessAffinityMask(process, 1);
		}
		if(GetPrivateProfileInt("Main", "VideoFix", 1, ".\\ddfix.ini")) {
			fix2=1;
			PROCESS_INFORMATION p;
			STARTUPINFO s;
			memset(&s, 0, sizeof(STARTUPINFO));
			s.cb=sizeof(STARTUPINFO);
			if(CreateProcessA(0, "regsvr32 /s LGVID.AX", 0, 0, false, 0, 0, 0, &s, &p)) {
				CloseHandle(p.hThread);
				WaitForInputIdle(p.hProcess, 100);
				CloseHandle(p.hProcess);
			}
		}

#ifdef CHECKEDBUILD
		LogFile=CreateFileA("ddfix-log.txt", GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_FLAG_WRITE_THROUGH, 0);
		DWORD unused;
		char msg[512];
		sprintf_s(msg, "v1.2.1, %dx%d\r\nDuel core fix: %d\r\nVideo fix: %d\r\n\r\n", gWidth, gHeight, fix1, fix2);
		WriteFile(LogFile, msg, strlen(msg), &unused, 0);
#endif
		bmpInit();
	} else if(dwReason==DLL_PROCESS_DETACH) {
		SavedDirectDraw->Release();
		bmpExit();
#ifdef CHECKEDBUILD
		CloseHandle(LogFile);
#endif
	}
	return true;
}

#ifdef CHECKEDBUILD
void Log(char* msg) {
	DWORD unused;
	WriteFile(LogFile, msg, strlen(msg), &unused, 0);
}
#endif

HRESULT _stdcall FakeDirectDrawCreate(GUID* a, IDirectDraw** b, IUnknown* c) {
	if(SavedDirectDraw) {
		*b=(IDirectDraw*)SavedDirectDraw;
		SavedDirectDraw->AddRef();
		return 0;
	}
	HRESULT hr=DirectDrawCreate(a,b,c);
	if(FAILED(hr)) return hr;
	SavedDirectDraw=new FakeDirectDraw(*b);
	*b=(IDirectDraw*)SavedDirectDraw;
	SavedDirectDraw->AddRef();
	return 0;
}